java抛出异常的几种情况小结

1. 编译错误

1
2
3
4
5
//代码1
public static void test() throws Exception {
throw new Exception("参数越界");
System.out.println("异常后"); //编译错误,「无法访问的语句」
}

2.可以执行

1
2
3
4
5
6
7
//代码2
try{
throw new Exception("参数越界");
}catch(Exception e) {
e.printStackTrace();
}
System.out.println("异常后");//可以执行

3. 抛出异常,不执行

//代码3
if(true) {
throw new Exception(“参数越界”);
}
System.out.println(“异常后”); //抛出异常,不会执行

总结 :

若一段代码前有异常抛出,并且这个异常没有被捕获,这段代码将产生编译时错误「无法访问的语句」。如代码1
若一段代码前有异常抛出,并且这个异常被try…catch所捕获,若此时catch语句中没有抛出新的异常,则这段代码能够被执行,否则,同第1条。如代码2
若在一个条件语句中抛出异常,则程序能被编译,但后面的语句不会被执行。如代码3
另外总结一下运行时异常与非运行时异常的区别:

运行时异常是RuntimeException类及其子类的异常,是非受检异常,如NullPointerException、IndexOutOfBoundsException等。由于这类异常要么是系统异常,无法处理,如网络问题;
要么是程序逻辑错误,如空指针异常;JVM必须停止运行以改正这种错误,所以运行时异常可以不进行处理(捕获或向上抛出,当然也可以处理),而由JVM自行处理。Java
Runtime会自动catch到程序throw的RuntimeException,然后停止线程,打印异常。
非运行时异常是RuntimeException以外的异常,类型上都属于Exception类及其子类,是受检异常。非运行时异常必须进行处理(捕获或向上抛出),如果不处理,程序将出现编译错误。一般情况下,API中写了throws的Exception都不是RuntimeException。

常见运行时异常:

java抛出异常的几种情况小结插图

常见非运行时异常:

java抛出异常的几种情况小结插图1

Java中异常问题(异常抛出后是否继续执行的问题)

1
2
3
4
public static void test() throws Exception {
throw new Exception("参数越界");
System.out.println("异常后"); //编译错误,「无法访问的语句」
}
1
2
3
4
5
6
7
8
//代码2
//异常被捕获,日志打印了异常,代码继续执行
try{
throw new Exception("参数越界");
}catch(Exception e) {
e.printStackTrace();
}
System.out.println("异常后");//可以执行
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
//psvm 快捷键
public static void main(String[] args) {
try {
test();
} catch (Exception e) {
e.printStackTrace();
}
}
public static void test() throws Exception {
//代码3
if(true) {
throw new Exception("参数越界");
}
System.out.println("异常后"); //抛出异常,不会执行
}
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
public static void test() throws Exception {
//代码4
try {
int i=1/0;
} catch (Exception e) {
e.printStackTrace();
throw new Exception("代码执行异常后打印并抛出异常提示");
}
System.out.println("异常后"); //抛出异常,不会执行
}
//打印日志
java.lang.ArithmeticException: / by zero
at zmc.eter.etern.text.text.test(text.java:23)
at zmc.eter.etern.text.text.main(text.java:14)
java.lang.Exception: 代码执行异常后打印并抛出异常提示
at zmc.eter.etern.text.text.test(text.java:26)
at zmc.eter.etern.text.text.main(text.java:14)

标签

发表评论